#ifndef __BOOST__IO__FORMATLIST__IPP
#define __BOOST__IO__FORMATLIST__IPP
   // basic format manipulator:

   template< typename ForwardIterator >
   boost::io::formatlist_t< ForwardIterator > boost::io::formatlist
   (
      ForwardIterator first,
      ForwardIterator last
   )
   {
      return( formatlist_t< ForwardIterator >( first, last ));
   }

   template< typename Container >
   boost::io::formatlist_t< typename Container::iterator > boost::io::formatlist
   (
      Container & c
   )
   {
      return( formatlist_t< typename Container::iterator >( c.begin(), c.end()));
   }

   // advanced format manipulator:

   template< typename FormatType, typename ForwardIterator >
   boost::io::formatlist_t< ForwardIterator, FormatType > boost::io::formatlistex
   (
      ForwardIterator first,
      ForwardIterator last
   )
   {
      return( formatlist_t< ForwardIterator, FormatType >( first, last ));
   }

   template< typename FormatType, typename Container >
   boost::io::formatlist_t< typename Container::iterator, FormatType > boost::io::formatlistex
   (
      Container & c
   )
   {
      return( formatlist_t< typename Container::iterator, FormatType >( c.begin(), c.end()));
   }
#endif
