#ifndef __BOOST__IO__FORMATLIST_T__IPP
#define __BOOST__IO__FORMATLIST_T__IPP
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType >::listfmt_type
   boost::io::formatlist_t< ForwardIterator, FormatType >::openlist() const throw()
   {
      return( __openlist );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType >::listfmt_type
   boost::io::formatlist_t< ForwardIterator, FormatType >::closelist() const throw()
   {
      return( __closelist );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType >::listfmt_type
   boost::io::formatlist_t< ForwardIterator, FormatType >::separator() const throw()
   {
      return( __separator );
   }

   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType > & boost::io::formatlist_t< ForwardIterator, FormatType >::format
   (
      listfmt_type ol,
      listfmt_type cl,
      listfmt_type s
   ) throw()
   {
      __openlist  = ol;
      __closelist = cl;
      __separator = s;
      return( *this );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType > & boost::io::formatlist_t< ForwardIterator, FormatType >::format
   (
      listfmt_type ol,
      listfmt_type cl
   ) throw()
   {
      __openlist  = ol;
      __closelist = cl;
      return( *this );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType > & boost::io::formatlist_t< ForwardIterator, FormatType >::format
   (
      listfmt_type s
   ) throw()
   {
      __separator = s;
      return( *this );
   }

   template< typename ForwardIterator, typename FormatType >
   bool boost::io::formatlist_t< ForwardIterator, FormatType >::spaceBeforeSep() const throw()
   {
      return( __spaceBeforeSep );
   }
   template< typename ForwardIterator, typename FormatType >
   bool boost::io::formatlist_t< ForwardIterator, FormatType >::spaceAfterSep() const throw()
   {
      return( __spaceAfterSep );
   }
   template< typename ForwardIterator, typename FormatType >
   bool boost::io::formatlist_t< ForwardIterator, FormatType >::spaceAroundList() const throw()
   {
      return( __spaceAroundList );
   }

   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType > &
   boost::io::formatlist_t< ForwardIterator, FormatType >::space( bool bs, bool as, bool al ) throw()
   {
      __spaceBeforeSep  = bs;
      __spaceAfterSep   = as;
      __spaceAroundList = al;
      return( *this );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType > &
   boost::io::formatlist_t< ForwardIterator, FormatType >::space( bool bs, bool as ) throw()
   {
      __spaceBeforeSep  = bs;
      __spaceAfterSep   = as;
      return( *this );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType > &
   boost::io::formatlist_t< ForwardIterator, FormatType >::space( bool al ) throw()
   {
      __spaceAroundList = al;
      return( *this );
   }

   template< typename ForwardIterator, typename FormatType >
   ForwardIterator boost::io::formatlist_t< ForwardIterator, FormatType >::begin() const throw()
   {
      return( first );
   }
   template< typename ForwardIterator, typename FormatType >
   ForwardIterator boost::io::formatlist_t< ForwardIterator, FormatType >::end() const throw()
   {
      return( last );
   }
   template< typename ForwardIterator, typename FormatType >
   boost::io::formatlist_t< ForwardIterator, FormatType >::formatlist_t( ForwardIterator f, ForwardIterator l ):
      first( f ),
      last(  l )
   {
      __openlist  = traits_type::open_default;
      __closelist = traits_type::close_default;
      __separator = traits_type::seperator_default;
      __spaceBeforeSep  = false;
      __spaceAfterSep   = true;
      __spaceAroundList = true;
   }
   
   template
   <
      typename CharT, class TraitsT,
      typename ForwardIterator, typename FormatType
   >
   std::basic_ostream< CharT, TraitsT > & boost::io::operator<<
   (
      std::basic_ostream< CharT, TraitsT > & os,
      boost::io::formatlist_t< ForwardIterator, FormatType > const & fi
   )
   {
      typedef boost::io::formatlist_t< ForwardIterator, FormatType >::traits_type
                                                           traits_type;

      ForwardIterator                  first = fi.begin();
      ForwardIterator                  last  = fi.end();

      if( traits_type::isok( fi.openlist()))
         os << fi.openlist();

      if( fi.spaceAroundList())        os << static_cast< CharT >( ' ' );

      while( first != last )
      {
         os << *first++;
         if( first != last )
         {
            if( fi.spaceBeforeSep())   os << static_cast< CharT >( ' ' );

            if( traits_type::isok( fi.separator()))
               os << fi.separator();

            if( fi.spaceAfterSep())    os << static_cast< CharT >( ' ' );
         }
      }

      if( fi.spaceAroundList())        os << static_cast< CharT >( ' ' );

      if( traits_type::isok( fi.closelist()))
         os << fi.closelist();

      return( os );
   }
#endif
